{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 2006-2023 FreeXP, http://www.freexp.de                      }
{                                                                 }
{ Dieser Quelltext dient ausschlielich dazu, in FreeXP           }
{ verwendete Quelltexte Dritter, die von FreeXP modifiziert       }
{ wurden, auch in anderen Programmen als FreeXP verwenden zu      }
{ knnen.                                                         }
{ --------------------------------------------------------------- }
{ $Id: freexp.pas,v 1.11 2010-06-13 10:34:23 mw Exp $ }
{ Unit freexp }
unit freexp;
{$I-}

{$IFDEF VER70 }
  {$DEFINE BP}
  {$IFDEF WINDOWS}
    {$DEFINE Win16}
  {$ENDIF }
{$ELSE}
  {$IFDEF VER80 }
    {$DEFINE BP}
    {$IFDEF WINDOWS}
      {$DEFINE Win16}
    {$ENDIF }
  {$ENDIF }
{$ENDIF }

interface

const FMRead       = $00;     { Konstanten fr Filemode }
      FMWrite      = $01;
      FMRW         = $02;
      FMDenyNone   = $40;
      FMDenyRead   = $30;
      FMDenyWrite  = $20;
      FMDenyBoth   = $10;
      FMCompatible = $00;

procedure fm_ro;                                { Filemode ReadOnly       }
procedure fm_rw;                                { Filemode Read/Write     }
Function Hex(const l:longint; const n:byte):string;      { Hex-Zahl mit n Stellen       }
Function  existf(var f):boolean;                { Datei vorhanden ?       }
Function  exist(const n:string):boolean;         { Datei vorhanden ?       }

implementation

{$IFNDEF Win16 }
uses dos;
{$ELSE }
uses windos,strings;
{$ENDIF }

procedure fm_ro;      { Filemode ReadOnly }
begin
  filemode:=fmRead;
end;

procedure fm_rw;      { Filemode Read/Write }
begin
  filemode:=fmRW;
end;

function Hex(const l:longint; const n:byte):string;
const hexch : array[0..15] of char = '0123456789ABCDEF';
var   s    : string[8];
      f    : shortint;
      trim : boolean;
begin
  trim:=(n=0);
  if trim then f:=28 else f:=((n-1)*4);
  s:='';
  while f>=0 do begin
    s:=s+hexch[(l shr f)and $f];
    dec(f,4);
    end;
  if trim then
    while (length(s)>1) and (s[1]='0') do
      delete(s,1,1);
  Hex:=s;
end;

Function existf(var f):Boolean;
var
  fm : byte;
begin
  existf:=false;
  fm:=filemode;
  filemode:=FMDenyNone;
  reset(file(f));
  if IOResult=0 then
  begin
    close(file(f));
    existf:=true;
  end;
  filemode:=fm;
  if ioresult = 0 then ;
end;

function exist(const n:string):boolean;
var
  {$IFNDEF Win16 }
  sr : searchrec;
  {$ELSE }
  sr : Tsearchrec;
  sp : Array[0..255] of Char;
  {$ENDIF }
  ex : boolean;
begin
  {$IFNDEF Win16 }
  FindFirst(n,$27,sr);
  {$ELSE }
  StrPCopy(sp,n);
  FindFirst(sp,$27,sr);
  {$ENDIF }
  ex:=(doserror=0);
  while not ex and (doserror=0) do
  begin
    FindNext(sr);
    ex:=(doserror=0);
  end;
  {$IFNDEF BP }
  FindClose(sr);
  {$ENDIF }
  exist:=ex;
end;

end.
{
  $Log: not supported by cvs2svn $
  Revision 1.10  2008/12/26 18:37:13  mw
  - Aktualisierung auf Version 3.45

  Revision 1.9  2008-01-01 20:59:23  mw
  MW: - Frohes neues Jahr 2008

  Revision 1.8  2007/01/23 16:16:42  mw
  MW: - Neues Jahr 2007

  Revision 1.7  2006/08/29 20:40:44  mw
  MW: - Und noch ein Bugfix.

  Revision 1.6  2006/08/29 20:23:31  mw
  MW: - Und noch eine Sonderbehandlung fr Win16 und OS2.

  Revision 1.5  2006/08/29 20:00:50  mw
  MW: - Sonderbedingung fr Win16 und OS2

  Revision 1.4  2006/08/29 18:53:40  mw
  MW: - Sauberes Maskieren von FindClose()

  Revision 1.3  2006/08/29 18:46:46  mw
  MW: - Wieder nutzbar.

  Revision 1.2  2006/08/29 18:27:45  mw
  MW: - Weitere Existensfunktion bernommen.

  Revision 1.1  2006/04/20 07:20:42  mw
  MW: - Neue Unit FreeXP:
        Diese Unit enthlt Routinen die dazu dienen von FreeXP modifizierte
        Quelltexte Dritter (derzeit ist dies nur md5.pas) auerhalb von
        FreeXP zu kompilieren.

}
